//Interrupt example for the SX target

//This variable will be incremented in every
//interrupt call and written into the PORTB
char portState = 0;
char extraDivider = 0; //some extra divider because SX runs so fast :)

//Note temporary variables (like _code_tmp_0000)
//should be avoided in the interrupt code in the generated
//assembler because it might cause some collisions if the
//same temporary variables are used in the main code. Or
//vice versa temporary variables could be used in the interrupt
//code but than they should be avoided in the main code.
void interrupt( void )
{   
    extraDivider++;
    if( extraDivider == 0 )
        output_port_b( portState++ );
}

void main( void )
{
    //Hardware Initialization
    set_tris_b( ~15 );
    output_port_b( portState );
    
    set_option( 135 ); //set divider 1:256
    
    //Start endless loop
    while( 1 );
}
